/*****************************************************
This program was produced by the
CodeWizardAVR V1.24.8b Professional
Automatic Program Generator
 Copyright 1998-2006 Pavel Haiduc, HP InfoTech s.r.l.
http://www.hpinfotech.com

Project : 
Version : 
Date    : 07.03.2009
Author  : F4CG                            
Company : F4CG                            
Comments: 


Chip type           : ATmega32
Program type        : Application
Clock frequency     : 14,745600 MHz
Memory model        : Small
External SRAM size  : 0
Data Stack size     : 512
*****************************************************/

#include <mega32.h>
#include <delay.h>
#include <stdio.h>

// Alphanumeric LCD Module functions
#asm
   .equ __lcd_port=0x15 ;PORTD
#endasm
#include <lcd.h>

#define ADC_VREF_TYPE 0x00
#define LOCKED   PINB.0
#define LE   PORTB.1
#define DATA PORTB.2
#define CLK  PORTB.3

#define RLATCH 0x0640 //4MHz osc, 400 divider
//#define NLATCH 0x1 | (0x04<<2) | (0x04D5<<7) //99.00MHz vco, 1237 B divider, 4 A divider
//#define NLATCH 0x1 | (0x00<<2) | (0x04E2<<7) //100.00MHz vco, 1250 B divider, 0 A divider

#define CNTRES 0
#define PWRDN  0
#define FoLD   0x05  //Digital Lock Detect
#define PDPOL  0
#define CPTRIST 0
#define FLM   1
#define TEST  0x00
#define PWRDNM 0

#define FLATCH 0x2 | (CNTRES<<2) | (PWRDN<<3) | (FoLD<<4) | (PDPOL<<7) | (CPTRIST<<8) | (FLM<<9) | (TEST<<16) | (PWRDNM<<19) //

#define MIN_FREQ 87500
#define MAX_FREQ 108000

eeprom unsigned long int start_freq = 99000;

// Read the AD conversion result
unsigned int read_adc(unsigned char adc_input)
{
ADMUX=adc_input|ADC_VREF_TYPE;
// Start the AD conversion
ADCSRA|=0x40;
// Wait for the AD conversion to complete
while ((ADCSRA & 0x10)==0);
ADCSRA|=0x10;
return ADCW;
}

// Declare your global variables here
unsigned long int n;
//unsigned char t = 0x011;                 

// Timer 1 output compare A interrupt service routine
interrupt [TIM1_COMPA] void timer1_compa_isr(void)
{
// Place your code here
      #asm("cli")      
      n=0;
      #asm("sei")
}

// Timer 0 overflow interrupt service routine
interrupt [TIM0_OVF] void timer0_ovf_isr(void)
{
// Reinitialize Timer 0 value
TCNT0=0xFE;
// Place your code here
//PORTC.6=!PORTC.6;
n++;
}

void ssend (unsigned long int dat, unsigned char len)
{
  unsigned char tmp;
  unsigned long int mask = 0x01;
  tmp = len;
  mask <<= (len-1);
  LE = 0;
  CLK = 0;        
  while (len--)
  {  
      DATA = (dat & mask)>>(tmp-1);
      //delay_ms(2);
      CLK = 1;
      dat <<= 1;      
      //delay_ms(2);
      CLK = 0;
  };
  LE = 1;  
}

void set_freq(unsigned long int freq)
{ 
  unsigned long int A=0;
  unsigned long int B=3;
  B = freq / 80;
  A = (freq / 10) - B * 8;
  ssend(RLATCH, 21);
  ssend((0x1 | (A<<2) | (B<<7)), 21);
  ssend(FLATCH, 20);
  ssend(FLATCH|0x03, 20);
  //sprintf(s, "B=%d, A=%d", B, A);
  //sprintf(s, "%d, %d", 0x1 | (A<<2) | (B<<7), NLATCH);
  //lcd_putsf("Hello");
  //lcd_puts(s);
}

void main(void)
{

unsigned char locked_ = 2;
unsigned long int freq;
char s[20]; 
unsigned char prs_count;
unsigned char tmp1, tmp2, i;


PORTA=0x00;
DDRA=0x00;

PORTB=0x30;
DDRB=0x0E;
LE = 1;
CLK = 0;
DATA = 0;

PORTC=0x00;
DDRC=0xC0;

PORTD=0x00;
DDRD=0x00;

TCCR0=0x07;
TCNT0=0xFE;
OCR0=0x00;


TCCR1A=0x00;
TCCR1B=0x0D;
TCNT1H=0x00;
TCNT1L=0x00;
ICR1H=0x00;
ICR1L=0x00;
OCR1A=0xE100;
OCR1BH=0x00;
OCR1BL=0x00;


ASSR=0x00;
TCCR2=0x00;
TCNT2=0x00;
OCR2=0x00;

MCUCR=0x00;
MCUCSR=0x00;

TIMSK=0x10|0x01;

ACSR=0x80;
SFIOR=0x00;

ADMUX=ADC_VREF_TYPE;
ADCSRA=0x84;

// LCD module initialization
lcd_init(16);

for(i = 5; i > 0; i--)
{
lcd_gotoxy(0, 0);
sprintf(s, "SNT INIT %u", i);
lcd_puts(s);
delay_ms(1000);
}
set_freq(freq = start_freq);
      
#asm("sei") 
      
while (1)
      {
        if(locked_!=LOCKED)
        {
           if(!LOCKED) {lcd_gotoxy(0, 1); lcd_putsf("LOCKED");} else {lcd_gotoxy(0, 1); lcd_putsf("      ");}
        }
        locked_=LOCKED;
        delay_ms(50);
        //fine
        if (tmp1==0 && PINB.4==1 && prs_count!=10 && freq>MIN_FREQ)
        {
          freq -= 10;
          set_freq(freq);
        }
        if (tmp2==0 && PINB.5==1 && prs_count!=10 && freq<MAX_FREQ)
        {
          freq += 10;
          set_freq(freq);
        }
        //coarse
        if (!PINB.4 && freq>MIN_FREQ && PINB.5 && prs_count==10)
        {
          freq -= 100;
          if (freq < MIN_FREQ) freq = 87500;
          set_freq(freq);
        }
        if (!PINB.5 && freq<MAX_FREQ && PINB.4 && prs_count==10)
        {
          freq += 100;
          if (freq > MAX_FREQ) freq = 108000;
          set_freq(freq);
        }
        //saving
        if (!PINB.5 && !PINB.4)
        {
          start_freq = freq;
          lcd_gotoxy(0, 0);
          sprintf(s, "SAVED to EEPROM");
          lcd_puts(s);
          delay_ms(1000);
        }
        tmp1=PINB.4;
        tmp2=PINB.5;
        
        if (!PINB.4 || !PINB.5)
        {
          if (prs_count<10) prs_count++;
        } else prs_count = 0;
        
        lcd_gotoxy(0, 0);
        sprintf(s, "fvco %u0 kHz ", (unsigned int)(freq/10));
          lcd_puts(s);
      };
}
